com.google.appengine.api.memcache

## Interface AsyncMemcacheService

- All Superinterfaces:
    BaseMemcacheService

      public interface AsyncMemcacheService
      extends BaseMemcacheService

  An asynchronous version of `MemcacheService`. All methods return immediately and provide `Futures` as their return values.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `java.util.concurrent.Future<java.lang.Void>` | `clearAll()`
    `java.util.concurrent.Future<java.lang.Boolean>` | `contains(java.lang.Object key)`
    `java.util.concurrent.Future<java.lang.Boolean>` | `delete(java.lang.Object key)`
    `java.util.concurrent.Future<java.lang.Boolean>` | `delete(java.lang.Object key, long millisNoReAdd)`
    `<T> java.util.concurrent.Future<java.util.Set<T>>` | `deleteAll(java.util.Collection<T> keys)`
    `<T> java.util.concurrent.Future<java.util.Set<T>>` | `deleteAll(java.util.Collection<T> keys, long millisNoReAdd)`
    `java.util.concurrent.Future<java.lang.Object>` | `get(java.lang.Object key)`
    `<T> java.util.concurrent.Future<java.util.Map<T,java.lang.Object>>` | `getAll(java.util.Collection<T> keys)`
    `java.util.concurrent.Future<MemcacheService.IdentifiableValue>` | `getIdentifiable(java.lang.Object key)`
    `<T> java.util.concurrent.Future<java.util.Map<T,MemcacheService.IdentifiableValue>>` | `getIdentifiables(java.util.Collection<T> keys)`
    `java.util.concurrent.Future<Stats>` | `getStatistics()`
    `java.util.concurrent.Future<java.lang.Long>` | `increment(java.lang.Object key, long delta)`
    `java.util.concurrent.Future<java.lang.Long>` | `increment(java.lang.Object key, long delta, java.lang.Long initialValue)`
    `<T> java.util.concurrent.Future<java.util.Map<T,java.lang.Long>>` | `incrementAll(java.util.Collection<T> keys, long delta)`
    `<T> java.util.concurrent.Future<java.util.Map<T,java.lang.Long>>` | `incrementAll(java.util.Collection<T> keys, long delta, java.lang.Long initialValue)`
    `<T> java.util.concurrent.Future<java.util.Map<T,java.lang.Long>>` | `incrementAll(java.util.Map<T,java.lang.Long> offsets)`
    `<T> java.util.concurrent.Future<java.util.Map<T,java.lang.Long>>` | `incrementAll(java.util.Map<T,java.lang.Long> offsets, java.lang.Long initialValue)`
    `java.util.concurrent.Future<java.lang.Void>` | `put(java.lang.Object key, java.lang.Object value)`
    `java.util.concurrent.Future<java.lang.Void>` | `put(java.lang.Object key, java.lang.Object value, Expiration expires)`
    `java.util.concurrent.Future<java.lang.Boolean>` | `put(java.lang.Object key, java.lang.Object value, Expiration expires, MemcacheService.SetPolicy policy)`
    `java.util.concurrent.Future<java.lang.Void>` | `putAll(java.util.Map<?,?> values)`
    `java.util.concurrent.Future<java.lang.Void>` | `putAll(java.util.Map<?,?> values, Expiration expires)`
    `<T> java.util.concurrent.Future<java.util.Set<T>>` | `putAll(java.util.Map<T,?> values, Expiration expires, MemcacheService.SetPolicy policy)`
    `<T> java.util.concurrent.Future<java.util.Set<T>>` | `putIfUntouched(java.util.Map<T,MemcacheService.CasValues> values)`
    `<T> java.util.concurrent.Future<java.util.Set<T>>` | `putIfUntouched(java.util.Map<T,MemcacheService.CasValues> values, Expiration expiration)`
    `java.util.concurrent.Future<java.lang.Boolean>` | `putIfUntouched(java.lang.Object key, MemcacheService.IdentifiableValue oldValue, java.lang.Object newValue)`
    `java.util.concurrent.Future<java.lang.Boolean>` | `putIfUntouched(java.lang.Object key, MemcacheService.IdentifiableValue oldValue, java.lang.Object newValue, Expiration expires)`

    - ### Methods inherited from interface com.google.appengine.api.memcache.BaseMemcacheService

      `getErrorHandler, getNamespace, setErrorHandler`

- - ### Method Detail

    - #### get

          java.util.concurrent.Future<java.lang.Object> get(java.lang.Object key)

      See Also:
        `MemcacheService.get(Object)`

    - #### getIdentifiable

          java.util.concurrent.Future<MemcacheService.IdentifiableValue> getIdentifiable(java.lang.Object key)

      See Also:
        `MemcacheService.getIdentifiable(Object)`

    - #### getIdentifiables

          <T> java.util.concurrent.Future<java.util.Map<T,MemcacheService.IdentifiableValue>> getIdentifiables(java.util.Collection<T> keys)

      See Also:
        `MemcacheService.getIdentifiables(Collection)`

    - #### contains

          java.util.concurrent.Future<java.lang.Boolean> contains(java.lang.Object key)

      See Also:
        `MemcacheService.contains(Object)`

    - #### getAll

          <T> java.util.concurrent.Future<java.util.Map<T,java.lang.Object>> getAll(java.util.Collection<T> keys)

      See Also:
        `MemcacheService.getAll(Collection)`

    - #### put

          java.util.concurrent.Future<java.lang.Boolean> put(java.lang.Object key,
                                                             java.lang.Object value,
                                                             Expiration expires,
                                                             MemcacheService.SetPolicy policy)

      See Also:
        `MemcacheService.put(Object, Object, Expiration, SetPolicy)`

    - #### put

          java.util.concurrent.Future<java.lang.Void> put(java.lang.Object key,
                                                          java.lang.Object value,
                                                          Expiration expires)

      See Also:
        `MemcacheService.put(Object, Object, Expiration)`

    - #### put

          java.util.concurrent.Future<java.lang.Void> put(java.lang.Object key,
                                                          java.lang.Object value)

      See Also:
        `MemcacheService.put(Object, Object)`

    - #### putAll

          <T> java.util.concurrent.Future<java.util.Set<T>> putAll(java.util.Map<T,?> values,
                                                                   Expiration expires,
                                                                   MemcacheService.SetPolicy policy)

      See Also:
        `MemcacheService.putAll(Map, Expiration, SetPolicy)`

    - #### putAll

          java.util.concurrent.Future<java.lang.Void> putAll(java.util.Map<?,?> values,
                                                             Expiration expires)

      See Also:
        `MemcacheService.putAll(Map, Expiration)`

    - #### putAll

          java.util.concurrent.Future<java.lang.Void> putAll(java.util.Map<?,?> values)

      See Also:
        `MemcacheService.putAll(Map)`

    - #### putIfUntouched

          java.util.concurrent.Future<java.lang.Boolean> putIfUntouched(java.lang.Object key,
                                                                        MemcacheService.IdentifiableValue oldValue,
                                                                        java.lang.Object newValue,
                                                                        Expiration expires)

      See Also:
        `MemcacheService.putIfUntouched(Object, IdentifiableValue, Object, Expiration)`

    - #### putIfUntouched

          java.util.concurrent.Future<java.lang.Boolean> putIfUntouched(java.lang.Object key,
                                                                        MemcacheService.IdentifiableValue oldValue,
                                                                        java.lang.Object newValue)

      See Also:
        `MemcacheService.putIfUntouched(Object, IdentifiableValue, Object)`

    - #### putIfUntouched

          <T> java.util.concurrent.Future<java.util.Set<T>> putIfUntouched(java.util.Map<T,MemcacheService.CasValues> values)

      See Also:
        `MemcacheService.putIfUntouched(Map)`

    - #### putIfUntouched

          <T> java.util.concurrent.Future<java.util.Set<T>> putIfUntouched(java.util.Map<T,MemcacheService.CasValues> values,
                                                                           Expiration expiration)

      See Also:
        `MemcacheService.putIfUntouched(Map, Expiration)`

    - #### delete

          java.util.concurrent.Future<java.lang.Boolean> delete(java.lang.Object key)

      See Also:
        `MemcacheService.delete(Object)`

    - #### delete

          java.util.concurrent.Future<java.lang.Boolean> delete(java.lang.Object key,
                                                                long millisNoReAdd)

      See Also:
        `MemcacheService.delete(Object, long)`

    - #### deleteAll

          <T> java.util.concurrent.Future<java.util.Set<T>> deleteAll(java.util.Collection<T> keys)

      See Also:
        `MemcacheService.deleteAll(Collection)`

    - #### deleteAll

          <T> java.util.concurrent.Future<java.util.Set<T>> deleteAll(java.util.Collection<T> keys,
                                                                      long millisNoReAdd)

      See Also:
        `MemcacheService.deleteAll(Collection, long)`

    - #### increment

          java.util.concurrent.Future<java.lang.Long> increment(java.lang.Object key,
                                                                long delta)

      See Also:
        `MemcacheService.increment(Object, long)`

    - #### increment

          java.util.concurrent.Future<java.lang.Long> increment(java.lang.Object key,
                                                                long delta,
                                                                java.lang.Long initialValue)

      See Also:
        `MemcacheService.increment(Object, long, Long)`

    - #### incrementAll

          <T> java.util.concurrent.Future<java.util.Map<T,java.lang.Long>> incrementAll(java.util.Collection<T> keys,
                                                                                        long delta)

      See Also:
        `MemcacheService.incrementAll(Collection, long)`

    - #### incrementAll

          <T> java.util.concurrent.Future<java.util.Map<T,java.lang.Long>> incrementAll(java.util.Collection<T> keys,
                                                                                        long delta,
                                                                                        java.lang.Long initialValue)

      See Also:
        `MemcacheService.incrementAll(Collection, long, Long)`

    - #### incrementAll

          <T> java.util.concurrent.Future<java.util.Map<T,java.lang.Long>> incrementAll(java.util.Map<T,java.lang.Long> offsets)

      See Also:
        `MemcacheService.incrementAll(Map)`

    - #### incrementAll

          <T> java.util.concurrent.Future<java.util.Map<T,java.lang.Long>> incrementAll(java.util.Map<T,java.lang.Long> offsets,
                                                                                        java.lang.Long initialValue)

      See Also:
        `MemcacheService.incrementAll(Map, Long)`

    - #### clearAll

          java.util.concurrent.Future<java.lang.Void> clearAll()

      See Also:
        `MemcacheService.clearAll()`

    - #### getStatistics

          java.util.concurrent.Future<Stats> getStatistics()

      See Also:
        `MemcacheService.getStatistics()`